;UNINEVHK
;Program- and version-independent event hook uninstaller
;Copyright (C) Kevin Kofler, 2000
;please read the readme file before using this file

;A note for beginners:
;*** COMMENTS, LABELS AND VARIABLE NAMES WILL _NOT_   ***
;*** APPEAR ON THE CALCULATOR, SO I CAN USE _LONG_    ***
;*** NAMES OR COMMENTS AND 2 LABELS AT THE SAME PLACE ***
;*** _WITHOUT_ INCREASING THE FILE SIZE !             ***

  include "OS.h" ;You need the version included with TeOS
                  ;(because of the ROM_CALL2 macro).
                  ;If you want to use the TI-GCC IDE,
                  ;you have to copy this file to the
                  ;TI-GCC\ASM\INCLUDE folder (replacing the
                  ;older version given with TI-GCC).
  xdef _nostub ;no kernel required
  xdef _ti89 ;This is for both the TI-89 and the TI-92+.
  xdef _ti92plus
  xdef _main ;This is a program, not a library.

_main:
  movem.l a0-a6/d0-d7,-(a7) ;save all registers
  ROM_CALL2 EV_hook ;get the location of the event hook
  cmp.l #0,(a4) ;check if there is an event hook registered
  bne found
  pea.l notfoundST(PC) ;if none, display a "not found"
  bra return           ;error message
found:
  move.l (a4),a0 ;get the address of the event hook
  cmp.l #$40000,a0 ;if <$40000, it doesn't respect the
  bcs incompatible ;evHk convention (HW2 compatibility)
  sub.l #$40010,a0 ;remove: * $40000 for HW2 AMS 2.0x
                   ;          without HW2Patch
                   ;        * $10 to get the begin of the
                   ;          handle (if compatible)
  cmp.l #'evHk',(a0) ;check for signature
  beq compatible
incompatible:
  pea.l incompatibleST(PC) ;if incompatible, display an
  bra return               ;"incompatible" error message
compatible:
  move.l 12(a0),(a4) ;restore old event hook
  move.l 4(a0),uninstalledST ;replace the placeholder
  move.l 8(a0),uninstalled2  ;with the program name
  move.l a0,-(a7)
  ROM_CALL HeapPtrToHandle ;get the handle number
  addq.l #4,a7
  move.w d0,-(a7)
  ROM_CALL HeapFree ;free (unallocate) the handle
  addq.l #2,a7
  pea.l uninstalledST(PC) ;display "uninstalled" message
return:
  ROM_CALL ST_helpMsg ;display the message
  addq.l #4,a7
  movem.l (a7)+,a0-a6/d0-d7 ;restore all registers
  rts ;return
  
  EVEN

uninstalledST: dc.b '****'
uninstalled2: dc.b '**** TSR event hook uninstalled',0
notfoundST: dc.b 'No TSR event hook resident',0
incompatibleST: dc.b 'Incompatible TSR event hook',0

  EVEN

  END
